from __future__ import annotations

try:
    # Version generated by setuptools_scm during build
    from .version import __version__
except ImportError:
    __version__ = None

# Public API available directly from "zut" namespace. Requires only default dependencies (python-dotenv)
from .commands import add_func_command, add_module_command, add_package_commands, add_object_commands, command, run_command, exec_command, call_command
from .env import get_venv, configure_env
from .format import human_bytes, slugen, ExtendedJSONDecoder, ExtendedJSONEncoder, get_default_csv_dialect_name, format_subprocess_result, format_help_text, format_description_text
from .git import get_git_tags, get_git_hash, git_has_changes, check_git_version_tag
from .gpg import download_gpg_key, verify_gpg_signature
from .logging import configure_logging, get_logging_dictconfig
from .network import configure_proxy, check_connectivity, check_socket
from .tools import BaseTools, clean, lso

# NOTE: The following features are NOT available directly from "zut" namespace because they require extra dependencies
# zut.credentials               -> [credentials]: keyring, pywin32, tabulate
# zut.db and zut.db.postgresql  -> [postgresql]: psycopg2, and optionally [django]: see below
# zut.django                    -> [django]: django, djangorestframework (for zut.django.middleware), cmarkgfm (for zut.django.views.MarkdownTemplateView)
# zut.flexout                   -> [flexout]: tabulate
# zut.network.winhttp           -> [winhttp]: pywin32
